Sub Main()
    
    appspacePlayUrl$ = "https://play.app.com/d"   
    EnableZoneSupport(1)
    checkPasswordSettings()
    setTimeServer("")

    ' Wait for ip address
    while getIpAddress() = ""
        ShowMessage("No IP Address", 1000)
        sleep(500)
    end while

    mp = CreateObject("roMessagePort")

    ' Start of program
    m.htmlWidget = CreateHtmlWidget()
    m.htmlWidgetShown = false
    m.htmlWidget.SetUrl(appspacePlayUrl$)
                        m.htmlWidget.Show()
                        m.htmlWidgetShown = true
                        m.htmlWidget.SetPort(mp)

    while true
        ev = mp.WaitMessage(0)
        if type(ev) = "roHtmlWidgetEvent" then
            evData = ev.GetData()
            if evData.reason = "message" then
                if evData.message.command = "getIpAddress" then
                    m.htmlWidget.PostJSMessage({id:evData.message.id, ipAddress:getIpAddress()})
                else if evData.message.command = "reboot" then
                    RebootSystem()
                else if evData.message.command = "createDirectory" then
                    res = ParseJson(evData.message.json)
                    m.htmlWidget.PostJSMessage({id:evData.message.id, result:AppCreateDir(res.dirs)})
                else if evData.message.command = "removeDirectory" then
                    m.htmlWidget.PostJSMessage({id:evData.message.id, result:DeleteDirectory(evData.message.path)})
                else if evData.message.command = "createFile" then
                    res = ParseJson(evData.message.json)
                    m.htmlWidget.PostJSMessage({id:evData.message.id, result:AppCreateFile(res.dirs, res.fullname)})
                else if evData.message.command = "checkFile" then
                    m.htmlWidget.PostJSMessage({id:evData.message.id, result:AppCheckFile(evData.message.parent, evData.message.name)})
                else if evData.message.command = "moveFile" then
                    res = ParseJson(evData.message.json)
                    m.htmlWidget.PostJSMessage({id:evData.message.id, result:AppMoveFile(res.dirs, res.fullname1, res.fullname2)})
                else if evData.message.command = "removeFile" then
                    m.htmlWidget.PostJSMessage({id:evData.message.id, result:DeleteFile(evData.message.path)})
                else if evData.message.command = "updateAutorunFile" then
                    m.htmlWidget.PostJSMessage({id:evData.message.id, result:UpdateAutorunFile(evData.message.content)})
                else if evData.message.command = "downloadUrl" then
                    res = ParseJson(evData.message.json)
                    m.htmlWidget.PostJSMessage({id:evData.message.id, result:AppDownloadUrl(res.dirs, res.url, res.fullname)})
                else if evData.message.command = "getAvailableStorage" then
                    si=CreateObject("roStorageInfo", "app/data")
                    m.htmlWidget.PostJSMessage({id:evData.message.id, free:si.GetFreeInMegabytes(), total:si.GetSizeInMegabytes()})
                end if
            end if
        end if
    end while

End Sub
'''''''''''''''''''''''''''
Function ShowMessage(msg as String, time as Integer)

    vm=CreateObject("roVideoMode")
    width=vm.GetResX()
    height=vm.GetResY()
    rect=CreateObject("roRectangle", 0, 0, width, height)
    textWidget = CreateObject("roTextWidget", rect, 1, 2, 1)
    r = CreateObject("roRectangle", 30, 30, width - 30, 60)
    textWidget.SetSafeTextRegion(r)
    textWidget.PushString(msg)
    textWidget.Show()
    sleep(time)

End Function
'''''''''''''''''''''''''''
Function CreateHtmlWidget()

    vm=CreateObject("roVideoMode")
    vm.SetMode("1920x1080x60p")
    width=vm.GetResX()
    height=vm.GetResY()
    rect=CreateObject("roRectangle", 0, 0, width, height)
    htmlWidget = CreateObject("roHtmlWidget", rect)
    htmlWidget.SetHWZDefault("on")
    htmlWidget.EnableSecurity(false)
    htmlWidget.EnableJavascript(true)
    htmlWidget.EnableMouseEvents(true)
    htmlWidget.StartInspectorServer(2999)
    htmlWidget.SetLocalStorageDir("SD:/localdb")
    htmlWidget.SetAppCacheDir("SD:/appcache")
    jsClasses = CreateObject("roAssociativeArray")
    jsClasses["all"] = [ "*" ]
    jsClasses["*"] = [ "*" ]
    htmlWidget.AllowJavaScriptURLs(jsClasses)
    return htmlWidget

End Function
'''''''''''''''''''''''''''
Function getIpAddress()

    ipAddress$ = ""
    nc = CreateObject("roNetworkConfiguration", 0)
    if type(nc) = "roNetworkConfiguration" then ipAddress$ = nc.GetCurrentConfig().ip4_address
    if ipAddress$ <> "" then return ipAddress$
    nc = CreateObject("roNetworkConfiguration", 1)
    if type(nc) = "roNetworkConfiguration" then ipAddress$ = nc.GetCurrentConfig().ip4_address
    return ipAddress$

End Function
'''''''''''''''''''''''''''
Function AppCreateDir(dirs as Object)

    For i = 0 to dirs.Count()-1
        res = CreateDirectory(dirs[i])
    Next
    return true

End Function
'''''''''''''''''''''''''''
Function AppCheckFile(parent as String, name as String)

    mf = MatchFiles(parent, name)
    For i = 0 to mf.Count()-1
        if mf[i]=name then return true
    Next
    return false

End Function
'''''''''''''''''''''''''''
Function AppCreateFile(dirs as Object, fullname as String)

    AppCreateDir(dirs)
    return WriteAsciiFile(fullname, "")

End Function
'''''''''''''''''''''''''''
Function AppMoveFile(dirs as Object, fullname1 as String, fullname2 as String)

    AppCreateDir(dirs)
    return MoveFile(fullname1, fullname2)

End Function
'''''''''''''''''''''''''''
Function AppDownloadUrl(dirs as Object, url as String, fullname as String)

    AppCreateDir(dirs)
    u = CreateObject("roUrlTransfer")
    u.SetUrl(url)
    return u.GetToFile(fullname)

End Function
'''''''''''''''''''''''''''
Function checkPasswordSettings()

    if AppCheckFile("", "passwordreset") = false then return false
    nc = CreateObject("roNetworkConfiguration", 0)
    if type(nc) <> "roNetworkConfiguration" then return false
    aa = CreateObject("roAssociativeArray")
    aa.AddReplace("open", "default")
    nc.SetupDWS(aa)
    nc.Apply()
    DeleteFile("passwordreset")

End Function
'''''''''''''''''''''''''''
Function setTimeServer(url as String)

    if url = "" then return false
    nc = CreateObject("roNetworkConfiguration", 0)
    if type(nc) <> "roNetworkConfiguration" then return false
    nc.SetTimeServer(url)
    nc.Apply()

End Function
'''''''''''''''''''''''''''
Function UpdateAutorunFile(content as String)

    return WriteAsciiFile("autorun.brs", content)

End Function
'''''''''''''''''''''''''''
